<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>List students</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body>
    <div class="container w-50">
        <div class="text-center m-3">
            <h3>THÔNG TIN SINH VIÊN</h3>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <button onclick="onBtnLayThongTin()" class="btn btn-primary">Lấy thông tin</button>
            </div>
            <label class="col-form-label col-sm-4">Số lượng sinh viên:
                <span id="span-num-students" class="text-danger font-weight-bold">1000</span>
            </label>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">Danh sách ID sinh viên:
                <span id="span-id-student-list" class="text-danger">3, 4, 7, 8, 9, 10</span>
            </div>
        </div>
        <br>
        <hr>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-student-id">Nhập Id sinh viên <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-5">
                <input id="input-student-id" placeholder="Nhập id sinh viên ..." class="form-control">
            </div>
            <div class="col-sm-3">
                <button onclick="onBtnxemChiTiet()" class="btn btn-primary" style="background-color: blueviolet;">Xem chi tiết</button>
            </div>
        </div>
        <hr>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-student-code">Student Code</label>
            <div class="col-sm-3">
                <input id="input-student-code" placeholder="Student Code" class="form-control">
            </div>
            <label class="col-form-label col-sm-3" for="input-username">Username</label>
            <div class="col-sm-3">
                <input id="input-username" placeholder="Username" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-firstname">First name</label>
            <div class="col-sm-3">
                <input id="input-firstname" placeholder="First name" class="form-control">
            </div>
            <label class="col-form-label col-sm-3" for="input-lastname">Last name</label>
            <div class="col-sm-3">
                <input id="input-lastname" placeholder="Last name" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-birthday">Birthday</label>
            <div class="col-sm-3">
                <input type="text" id="input-birthday" placeholder="Birthday" class="form-control">
            </div>
            <label class="col-form-label col-sm-3" for="input-study-year">Study year</label>
            <div class="col-sm-3">
                <input type="text" id="input-study-year" placeholder="Study year" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-email">Email</label>
            <div class="col-sm-9">
                <input type="text" id="input-email" placeholder="Email" class="form-control">
            </div>
        </div>
    </div>
</body>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;

    const gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện nhấn nút Lấy thông tin
    function onBtnLayThongTin() {
        var vSoSinhVien = {
            id: ""
        };
        onGetStudentListClick(vSoSinhVien)
    }

    //hàm xử lý sự kiện nhấn nút xem chi tiết
    function onBtnxemChiTiet() {
        var vSinhVienObj = {
            id: ""
        }
        //B1: Đọc Dữ liệu
        thuThapDuLieu(vSinhVienObj);
        //B2: Kiểm tra dữ liệu
        var vKiemTra = validate(vSinhVienObj);
        if (vKiemTra == true) {
            //B3: Gọi APTI
            onGetStudentByIdClick(vSinhVienObj);
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm gọi API lấy danh sách sinh viên
    function onGetStudentListClick() {
        var vAPI_URL = gBASE_URL + "/students";
        var vXhttp = new XMLHttpRequest();
        vXhttp.open("GET", vAPI_URL, false);
        vXhttp.send();
        if (vXhttp.status == gREQUEST_STATUS_OK) {
            console.log(vXhttp.responseText);
            hienThiDuLieu(vXhttp);
        }
    }
    //xử lý hiển thị số lượn danh sách sv
    function hienThiDuLieu(paramXhttp) {
        var vSoLuongObj = JSON.parse(paramXhttp.responseText);
        var soLuong = Object.keys(vSoLuongObj).length
        var vSoLuongSV = document.getElementById("span-num-students");
        var vIdSV = document.getElementById("span-id-student-list");
        vIdSV.innerHTML = "",
            vSoLuongSV.innerHTML = soLuong;
        for (var i = 0; i < vSoLuongObj.length; i++) {
            vIdSV.innerHTML += vSoLuongObj[i].id + ",";
        }
    }
    //hàm đọc dữ liệu id input
    function thuThapDuLieu(paramSinhVienObj) {
        var vIDinput = document.getElementById("input-student-id");
        paramSinhVienObj.id = vIDinput.value.trim();
    }
    //Hàm kiểm tra dữ liệu
    function validate(paramSinhVienObj) {
        if (paramSinhVienObj.id == "") {
            alert("Id phải nhập vào!");
            return false;
        }
        if (isNaN(paramSinhVienObj.id)) {
            alert("Id phải là số");
            return false;
        }
        return true;
    }
    // API lấy chi tiết 01 sinh viên by id
    function onGetStudentByIdClick() {
        const vAPI_URL = gBASE_URL + "/students/";
        var vInputId = document.getElementById("input-student-id");
        var vStudentId = vInputId.value;

        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", vAPI_URL + vStudentId, false);
        vXmlHttp.send();
        if (vXmlHttp.status == gREQUEST_STATUS_OK) {
            console.log(vXmlHttp.responseText);
            //B4: Xử lý hiển thị
            hienThiThongTinSV(vXmlHttp);
        }
        else {
            alert("Không tồn tạ Sinh Viên với ID đã nhập");
        }
    }
    // Hàm hiển thị thông tin sinh viên lên web
    function hienThiThongTinSV(paramXhttp) {
        var vSinhVienObject = JSON.parse(paramXhttp.responseText);
        var vStudentCode = document.getElementById("input-student-code");
        var vUserName = document.getElementById("input-username");
        var vFirstName = document.getElementById("input-firstname");
        var vLastName = document.getElementById("input-lastname");
        var vBirthday = document.getElementById("input-birthday");
        var vStudyYear = document.getElementById("input-study-year");
        var vEmail = document.getElementById("input-email");

        vStudentCode.value = vSinhVienObject.studentCode;
        vUserName.value = vSinhVienObject.username;
        vFirstName.value = vSinhVienObject.firstname;
        vLastName.value = vSinhVienObject.lastname;
        vBirthday.value = vSinhVienObject.birthday;
        vStudyYear.value = vSinhVienObject.studyYear;
        vEmail.value = vSinhVienObject.email;
    }
</script>

</html>